package kaysaar.aotd_question_of_loyalty.data.scripts.trackers;

import com.fs.starfarer.api.campaign.comm.IntelInfoPlugin;
import com.fs.starfarer.api.Global;
import java.util.Iterator;
import com.fs.starfarer.api.impl.campaign.intel.events.EventFactor;
import kaysaar.aotd_question_of_loyalty.data.intel.eventfactors.onetime.HubMissionFactor;
import kaysaar.aotd_question_of_loyalty.data.intel.AoTDCommIntelPlugin;
import kaysaar.aotd_question_of_loyalty.data.misc.QoLMisc;
import com.fs.starfarer.api.impl.campaign.missions.hub.BaseHubMission;
import java.util.ArrayList;
import com.fs.starfarer.api.EveryFrameScript;

public class AoTDHubMissionTracker implements EveryFrameScript
{
    protected ArrayList<BaseHubMission> baseCustomBounties;
    
    public AoTDHubMissionTracker() {
        this.baseCustomBounties = new ArrayList<BaseHubMission>();
    }
    
    public boolean isDone() {
        return false;
    }
    
    public boolean runWhilePaused() {
        return false;
    }
    
    public void advance(final float amount) {
        this.handleBarBounties();
    }
    
    private void handleBarBounties() {
        for (final BaseHubMission bounty : this.getBaseBounties()) {
            if (bounty.getResult() != null && QoLMisc.isCommissionedBy(bounty.getFactionForUIColors().getId()) && !this.isBaseBountyPresent(bounty)) {
                this.baseCustomBounties.add(bounty);
                int val = bounty.getCreditsReward() / 2000;
                if (!bounty.getResult().success) {
                    val *= -1;
                }
                bounty.getCreditsReward();
                AoTDCommIntelPlugin.get().addFactor((EventFactor)new HubMissionFactor(val, bounty.getBaseName()));
            }
        }
        final Iterator<BaseHubMission> iterator = this.baseCustomBounties.iterator();
        while (iterator.hasNext()) {
            final BaseHubMission baseCustomBounty = iterator.next();
            if (baseCustomBounty.isEnded()) {
                iterator.remove();
            }
        }
    }
    
    public ArrayList<BaseHubMission> getBaseBounties() {
        final ArrayList<BaseHubMission> bounties = new ArrayList<BaseHubMission>();
        for (final IntelInfoPlugin intelInfoPlugin : Global.getSector().getIntelManager().getIntel((Class)BaseHubMission.class)) {
            if (intelInfoPlugin instanceof final BaseHubMission baseHubMission) {
                bounties.add(baseHubMission);
            }
        }
        return bounties;
    }
    
    public boolean isBaseBountyPresent(final BaseHubMission bounty) {
        for (final BaseHubMission baseCustomBounty : this.baseCustomBounties) {
            if (bounty.getMissionId().equals(baseCustomBounty.getMissionId())) {
                return true;
            }
        }
        return false;
    }
}
